/[gentoo-x86]/eclass/linux-mod.eclass
Gentoo

Diff of /eclass/linux-mod.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.64 Revision 1.102
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-mod.eclass,v 1.64 2006/05/11 08:23:43 johnm Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-mod.eclass,v 1.102 2011/06/01 06:51:30 robbat2 Exp $
4 4
5# Description: This eclass is used to interface with linux-info in such a way
6# to provide the functionality required and initial functions
7# required to install external modules against a kernel source
8# tree.
9#
10# Maintainer: John Mylchreest <johnm@gentoo.org> 5# Author(s): John Mylchreest <johnm@gentoo.org>,
11# Copyright 2004 Gentoo Linux 6# Stefan Schweizer <genstef@gentoo.org>
7# Maintainer: kernel-misc@gentoo.org
12# 8#
13# Please direct your bugs to the current eclass maintainer :) 9# Please direct your bugs to the current eclass maintainer :)
10
11# @ECLASS: linux-mod.eclass
12# @MAINTAINER:
13# kernel-misc@gentoo.org
14# @BLURB: It provides the functionality required to install external modules against a kernel source tree.
15# @DESCRIPTION:
16# This eclass is used to interface with linux-info.eclass in such a way
17# to provide the functionality and initial functions
18# required to install external modules against a kernel source
19# tree.
14 20
15# A Couple of env vars are available to effect usage of this eclass 21# A Couple of env vars are available to effect usage of this eclass
16# These are as follows: 22# These are as follows:
17# 23
18# Env Var Option Default Description 24# @ECLASS-VARIABLE: KERNEL_DIR
19# KERNEL_DIR <string> /usr/src/linux The directory containing kernel 25# @DESCRIPTION:
20# the target kernel sources. 26# A string containing the directory of the target kernel sources. The default value is
21# ECONF_PARAMS <string> The parameters to pass to econf. 27# "/usr/src/linux"
28
29# @ECLASS-VARIABLE: ECONF_PARAMS
30# @DESCRIPTION:
31# It's a string containing the parameters to pass to econf.
22# If this is not set, then econf 32# If this is not set, then econf isn't run.
23# isn't run.
24# BUILD_PARAMS <string> The parameters to pass to emake.
25# BUILD_TARGETS <string> clean modules The build targets to pass to
26# make.
27# MODULE_NAMES <string> This is the modules which are
28# to be built automatically using
29# the default pkg_compile/install.
30# They are explained properly
31# below. It will only make
32# BUILD_TARGETS once in any
33# directory.
34 33
35# MODULE_NAMES - Detailed Overview 34# @ECLASS-VARIABLE: BUILD_PARAMS
35# @DESCRIPTION:
36# It's a string with the parameters to pass to emake.
37
38# @ECLASS-VARIABLE: BUILD_TARGETS
39# @DESCRIPTION:
40# It's a string with the build targets to pass to make. The default value is "clean modules"
41
42# @ECLASS-VARIABLE: MODULE_NAMES
43# @DESCRIPTION:
44# It's a string containing the modules to be built automatically using the default
45# src_compile/src_install. It will only make ${BUILD_TARGETS} once in any directory.
36# 46#
37# The structure of each MODULE_NAMES entry is as follows: 47# The structure of each MODULE_NAMES entry is as follows:
48#
38# modulename(libdir:srcdir:objdir) 49# modulename(libdir:srcdir:objdir)
50#
51# where:
52#
53# modulename = name of the module file excluding the .ko
54# libdir = place in system modules directory where module is installed (by default it's misc)
55# srcdir = place for ebuild to cd to before running make (by default it's ${S})
56# objdir = place the .ko and objects are located after make runs (by default it's set to srcdir)
57#
58# To get an idea of how these variables are used, here's a few lines
59# of code from around line 540 in this eclass:
60#
61# einfo "Installing ${modulename} module"
62# cd ${objdir} || die "${objdir} does not exist"
63# insinto /lib/modules/${KV_FULL}/${libdir}
64# doins ${modulename}.${KV_OBJ} || die "doins ${modulename}.${KV_OBJ} failed"
65#
39# for example: 66# For example:
40# MODULE_NAMES="module_pci(pci:${S}/pci:${S}) module_usb(usb:${S}/usb:${S})" 67# MODULE_NAMES="module_pci(pci:${S}/pci:${S}) module_usb(usb:${S}/usb:${S})"
41# 68#
42# what this would do is 69# what this would do is
70#
43# cd ${S}/pci 71# cd "${S}"/pci
44# make ${BUILD_PARAMS} ${BUILD_TARGETS} 72# make ${BUILD_PARAMS} ${BUILD_TARGETS}
45# cd ${S} 73# cd "${S}"
46# insinto /lib/modules/${KV_FULL}/pci 74# insinto /lib/modules/${KV_FULL}/pci
47# doins module_pci.${KV_OBJ} 75# doins module_pci.${KV_OBJ}
48# 76#
49# cd ${S}/usb 77# cd "${S}"/usb
50# make ${BUILD_PARAMS} ${BUILD_TARGETS} 78# make ${BUILD_PARAMS} ${BUILD_TARGETS}
51# cd ${S} 79# cd "${S}"
52# insinto /lib/modules/${KV_FULL}/usb 80# insinto /lib/modules/${KV_FULL}/usb
53# doins module_usb.${KV_OBJ} 81# doins module_usb.${KV_OBJ}
54#
55# if the srcdir isnt specified, it assumes ${S}
56# if the libdir isnt specified, it assumes misc.
57# if the objdir isnt specified, it assumes srcdir
58 82
59# There is also support for automatyed modules.d file generation. 83# There is also support for automated modprobe.d/modules.d(2.4) file generation.
60# This can be explicitly enabled by setting any of the following variables. 84# This can be explicitly enabled by setting any of the following variables.
85
86# @ECLASS-VARIABLE: MODULESD_<modulename>_ENABLED
87# @DESCRIPTION:
88# This is used to disable the modprobe.d/modules.d file generation otherwise the file will be
89# always generated (unless no MODULESD_<modulename>_* variable is provided). Set to "no" to disable
90# the generation of the file and the installation of the documentation.
91
92# @ECLASS-VARIABLE: MODULESD_<modulename>_EXAMPLES
93# @DESCRIPTION:
94# This is a bash array containing a list of examples which should
95# be used. If you want us to try and take a guess set this to "guess".
61# 96#
97# For each array_component it's added an options line in the modprobe.d/modules.d file
62# 98#
63# MODULESD_${modulename}_ENABLED This enables the modules.d file 99# options array_component
64# generation even if we dont 100#
65# specify any additional info. 101# where array_component is "<modulename> options" (see modprobe.conf(5))
66# MODULESD_${modulename}_EXAMPLES This is a bash array containing 102
67# a list of examples which should 103# @ECLASS-VARIABLE: MODULESD_<modulename>_ALIASES
68# be used. If you want us to try and 104# @DESCRIPTION:
69# take a guess. Set this to "guess" 105# This is a bash array containing a list of associated aliases.
70# MODULESD_${modulename}_ALIASES This is a bash array containing 106#
71# a list of associated aliases. 107# For each array_component it's added an alias line in the modprobe.d/modules.d file
72# MODULESD_${modulename}_ADDITIONS This is a bash array containing 108#
73# A list of additional things to 109# alias array_component
74# add to the bottom of the file. 110#
75# This can be absolutely anything. 111# where array_component is "wildcard <modulename>" (see modprobe.conf(5))
112
113# @ECLASS-VARIABLE: MODULESD_<modulename>_ADDITIONS
114# @DESCRIPTION:
115# This is a bash array containing a list of additional things to
116# add to the bottom of the file. This can be absolutely anything.
76# Each entry is a new line. 117# Each entry is a new line.
77# MODULES_${modulename}_DOCS This is a string list which contains 118
78# the full path to any associated 119# @ECLASS-VARIABLE: MODULESD_<modulename>_DOCS
79# documents for $modulename 120# @DESCRIPTION:
121# This is a string list which contains the full path to any associated
122# documents for <modulename>. These files are installed in the live tree.
123
124# @ECLASS-VARIABLE: KV_OBJ
125# @DESCRIPTION:
126# It's a read-only variable. It contains the extension of the kernel modules.
80 127
81# The order of these is important as both of linux-info and eutils contain 128# The order of these is important as both of linux-info and eutils contain
82# set_arch_to_kernel and set_arch_to_portage functions and the ones in eutils 129# set_arch_to_kernel and set_arch_to_portage functions and the ones in eutils
83# are deprecated in favor of the ones in linux-info. 130# are deprecated in favor of the ones in linux-info.
84# See http://bugs.gentoo.org/show_bug.cgi?id=127506 131# See http://bugs.gentoo.org/show_bug.cgi?id=127506
85 132
86inherit eutils linux-info multilib 133inherit eutils linux-info multilib
87EXPORT_FUNCTIONS pkg_setup pkg_postinst src_install src_compile pkg_postrm 134EXPORT_FUNCTIONS pkg_setup pkg_preinst pkg_postinst src_install src_compile pkg_postrm
88 135
89IUSE="" # don't put pcmcia here, rather in the ebuilds that actually support pcmcia 136IUSE="kernel_linux"
90SLOT="0" 137SLOT="0"
91DESCRIPTION="Based on the $ECLASS eclass" 138DESCRIPTION="Based on the $ECLASS eclass"
92RDEPEND="virtual/modutils 139RDEPEND="kernel_linux? ( sys-apps/module-init-tools )"
93 pcmcia? ( virtual/pcmcia )" 140DEPEND="${RDEPEND}
94DEPEND="sys-apps/sed 141 sys-apps/sed
95 pcmcia? ( virtual/pcmcia )" 142 kernel_linux? ( virtual/linux-sources )"
96 143
97# eclass utilities 144# eclass utilities
98# ---------------------------------- 145# ----------------------------------
99 146
100check_vermagic() { 147check_vermagic() {
148 debug-print-function ${FUNCNAME} $*
149
101 local curr_gcc_ver=$(gcc -dumpversion) 150 local curr_gcc_ver=$(gcc -dumpversion)
102 local tmpfile old_chost old_gcc_ver result=0 151 local tmpfile old_chost old_gcc_ver result=0
103 152
104 tmpfile=`find ${KV_DIR}/ -iname "*.o.cmd" -exec grep usr/lib/gcc {} \; -quit` 153 tmpfile=`find "${KV_DIR}/" -iname "*.o.cmd" -exec grep usr/lib/gcc {} \; -quit`
105 tmpfile=${tmpfile//*usr/lib} 154 tmpfile=${tmpfile//*usr/lib}
106 tmpfile=${tmpfile//\/include*} 155 tmpfile=${tmpfile//\/include*}
107 old_chost=${tmpfile//*gcc\/} 156 old_chost=${tmpfile//*gcc\/}
108 old_chost=${old_chost//\/*} 157 old_chost=${old_chost//\/*}
109 old_gcc_ver=${tmpfile//*\/} 158 old_gcc_ver=${tmpfile//*\/}
132 ewarn "to match the kernel, or recompile the kernel first." 181 ewarn "to match the kernel, or recompile the kernel first."
133 die "GCC Version Mismatch." 182 die "GCC Version Mismatch."
134 fi 183 fi
135} 184}
136 185
137unpack_pcmcia_sources() { 186# @FUNCTION: use_m
138 # So while the two eclasses exist side-by-side and also the ebuilds inherit 187# @RETURN: true or false
139 # both we need to check for PCMCIA_SOURCE_DIR, and if we find it, then we 188# @DESCRIPTION:
140 # bail out and assume pcmcia.eclass is working on it. 189# It checks if the kernel version is greater than 2.6.5.
141 [[ -n ${PCMCIA_SOURCE_DIR} ]] && return 1
142
143 if [[ -f "${1}" ]]; then
144 PCMCIA_SOURCE_DIR="${WORKDIR}/pcmcia-cs/"
145
146 ebegin "Decompressing pcmcia-cs sources"
147 mkdir -p ${PCMCIA_SOURCE_DIR}
148 tar -xjf ${1} -C ${PCMCIA_SOURCE_DIR}
149 eend $?
150
151 if [[ -f ${PCMCIA_SOURCE_DIR}/pcmcia-cs-version ]]; then
152 PCMCIA_VERSION=$(cat ${PCMCIA_SOURCE_DIR}/pcmcia-cs-version)
153 einfo "Found pcmcia-cs-${PCMCIA_VERSION}"
154 fi
155 fi
156}
157
158# Dummy function for compatibility.
159pcmcia_configure() { return 0; }
160
161pcmcia_src_unpack() {
162 local pcmcia_tbz="${ROOT}/usr/src/pcmcia-cs/pcmcia-cs-build-env.tbz2"
163
164 # if the kernel has pcmcia support built in, then we just ignore all this.
165 if linux_chkconfig_present PCMCIA; then
166 einfo "Kernel based PCMCIA support has been detected."
167 else
168 if kernel_is 2 4; then
169 unpack_pcmcia_sources ${pcmcia_tbz};
170 else
171 einfo "We have detected that you are running a 2.6 kernel"
172 einfo "but you are not using the built-in PCMCIA support."
173 einfo "We will assume you know what you are doing, but please"
174 einfo "consider using the built in PCMCIA support instead."
175 epause 10
176
177 unpack_pcmcia_sources ${pcmcia_tbz};
178 fi
179 fi
180}
181
182use_m() { 190use_m() {
191 debug-print-function ${FUNCNAME} $*
192
183 # if we haven't determined the version yet, we need too. 193 # if we haven't determined the version yet, we need too.
184 get_version; 194 get_version;
185 195
186 # if the kernel version is greater than 2.6.6 then we should use 196 # if the kernel version is greater than 2.6.6 then we should use
187 # M= instead of SUBDIRS= 197 # M= instead of SUBDIRS=
198 [ ${KV_MAJOR} -eq 3 ] && return 0
188 [ ${KV_MAJOR} -eq 2 -a ${KV_MINOR} -gt 5 -a ${KV_PATCH} -gt 5 ] && \ 199 [ ${KV_MAJOR} -eq 2 -a ${KV_MINOR} -gt 5 -a ${KV_PATCH} -gt 5 ] && \
189 return 0 || return 1 200 return 0 || return 1
190} 201}
191 202
203# @FUNCTION: convert_to_m
204# @USAGE: /path/to/the/file
205# @DESCRIPTION:
206# It converts a file (e.g. a makefile) to use M= instead of SUBDIRS=
192convert_to_m() { 207convert_to_m() {
208 debug-print-function ${FUNCNAME} $*
209
193 if use_m 210 if use_m
194 then 211 then
195 [ ! -f "${1}" ] && \ 212 [ ! -f "${1}" ] && \
196 die "convert_to_m() requires a filename as an argument" 213 die "convert_to_m() requires a filename as an argument"
197 ebegin "Converting ${1/${WORKDIR}\//} to use M= instead of SUBDIRS=" 214 ebegin "Converting ${1/${WORKDIR}\//} to use M= instead of SUBDIRS="
198 sed -i 's:SUBDIRS=:M=:g' ${1} 215 sed -i 's:SUBDIRS=:M=:g' "${1}"
199 eend $? 216 eend $?
200 fi 217 fi
201} 218}
202 219
220# internal function
221#
222# FUNCTION: update_depmod
223# DESCRIPTION:
224# It updates the modules.dep file for the current kernel.
203update_depmod() { 225update_depmod() {
226 debug-print-function ${FUNCNAME} $*
227
204 # if we haven't determined the version yet, we need too. 228 # if we haven't determined the version yet, we need too.
205 get_version; 229 get_version;
206 230
207 ebegin "Updating module dependencies for ${KV_FULL}" 231 ebegin "Updating module dependencies for ${KV_FULL}"
208 if [ -r ${KV_OUT_DIR}/System.map ] 232 if [ -r "${KV_OUT_DIR}"/System.map ]
209 then 233 then
210 depmod -ae -F ${KV_OUT_DIR}/System.map -b ${ROOT} -r ${KV_FULL} 234 depmod -ae -F "${KV_OUT_DIR}"/System.map -b "${ROOT}" -r ${KV_FULL}
211 eend $? 235 eend $?
212 else 236 else
213 ewarn 237 ewarn
214 ewarn "${KV_OUT_DIR}/System.map not found." 238 ewarn "${KV_OUT_DIR}/System.map not found."
215 ewarn "You must manually update the kernel module dependencies using depmod." 239 ewarn "You must manually update the kernel module dependencies using depmod."
216 eend 1 240 eend 1
217 ewarn 241 ewarn
218 fi 242 fi
219} 243}
220 244
245# internal function
246#
247# FUNCTION: update_modules
248# DESCRIPTION:
249# It calls the update-modules utility.
221update_modules() { 250update_modules() {
251 debug-print-function ${FUNCNAME} $*
252
222 if [ -x /sbin/modules-update ] && \ 253 if [ -x /sbin/update-modules ] && \
223 grep -v -e "^#" -e "^$" ${D}/etc/modules.d/* >/dev/null 2>&1; then 254 grep -v -e "^#" -e "^$" "${D}"/etc/modules.d/* >/dev/null 2>&1; then
224 ebegin "Updating modules.conf" 255 ebegin "Updating modules.conf"
225 /sbin/modules-update 256 /sbin/update-modules
226 eend $? 257 eend $?
258 elif [ -x /sbin/update-modules ] && \
259 grep -v -e "^#" -e "^$" "${D}"/etc/modules.d/* >/dev/null 2>&1; then
260 ebegin "Updating modules.conf"
261 /sbin/update-modules
262 eend $?
227 fi 263 fi
228} 264}
229 265
266# internal function
267#
268# FUNCTION: move_old_moduledb
269# DESCRIPTION:
270# It updates the location of the database used by the module-rebuild utility.
230move_old_moduledb() { 271move_old_moduledb() {
272 debug-print-function ${FUNCNAME} $*
273
231 local OLDDIR=${ROOT}/usr/share/module-rebuild/ 274 local OLDDIR="${ROOT}"/usr/share/module-rebuild/
232 local NEWDIR=${ROOT}/var/lib/module-rebuild/ 275 local NEWDIR="${ROOT}"/var/lib/module-rebuild/
233 276
234 if [[ -f ${OLDDIR}/moduledb ]]; then 277 if [[ -f "${OLDDIR}"/moduledb ]]; then
235 [[ ! -d ${NEWDIR} ]] && mkdir -p ${NEWDIR} 278 [[ ! -d "${NEWDIR}" ]] && mkdir -p "${NEWDIR}"
236 [[ ! -f ${NEWDIR}/moduledb ]] && \ 279 [[ ! -f "${NEWDIR}"/moduledb ]] && \
237 mv ${OLDDIR}/moduledb ${NEWDIR}/moduledb 280 mv "${OLDDIR}"/moduledb "${NEWDIR}"/moduledb
238 rm -f ${OLDDIR}/* 281 rm -f "${OLDDIR}"/*
239 rmdir ${OLDDIR} 282 rmdir "${OLDDIR}"
240 fi 283 fi
241} 284}
242 285
286# internal function
287#
288# FUNCTION: update_moduledb
289# DESCRIPTION:
290# It adds the package to the /var/lib/module-rebuild/moduledb database used by the module-rebuild utility.
243update_moduledb() { 291update_moduledb() {
292 debug-print-function ${FUNCNAME} $*
293
244 local MODULEDB_DIR=${ROOT}/var/lib/module-rebuild/ 294 local MODULEDB_DIR="${ROOT}"/var/lib/module-rebuild/
245 move_old_moduledb 295 move_old_moduledb
246 296
247 if [[ ! -f ${MODULEDB_DIR}/moduledb ]]; then 297 if [[ ! -f "${MODULEDB_DIR}"/moduledb ]]; then
248 [[ ! -d ${MODULEDB_DIR} ]] && mkdir -p ${MODULEDB_DIR} 298 [[ ! -d "${MODULEDB_DIR}" ]] && mkdir -p "${MODULEDB_DIR}"
249 touch ${MODULEDB_DIR}/moduledb 299 touch "${MODULEDB_DIR}"/moduledb
250 fi 300 fi
301
251 if [[ -z $(grep ${CATEGORY}/${PN}-${PVR} ${MODULEDB_DIR}/moduledb) ]]; then 302 if ! grep -qs ${CATEGORY}/${PN}-${PVR} "${MODULEDB_DIR}"/moduledb ; then
252 einfo "Adding module to moduledb." 303 einfo "Adding module to moduledb."
253 echo "a:1:${CATEGORY}/${PN}-${PVR}" >> ${MODULEDB_DIR}/moduledb 304 echo "a:1:${CATEGORY}/${PN}-${PVR}" >> "${MODULEDB_DIR}"/moduledb
254 fi 305 fi
255} 306}
256 307
308# internal function
309#
310# FUNCTION: remove_moduledb
311# DESCRIPTION:
312# It removes the package from the /var/lib/module-rebuild/moduledb database used by
313# the module-rebuild utility.
257remove_moduledb() { 314remove_moduledb() {
315 debug-print-function ${FUNCNAME} $*
316
258 local MODULEDB_DIR=${ROOT}/var/lib/module-rebuild/ 317 local MODULEDB_DIR="${ROOT}"/var/lib/module-rebuild/
259 move_old_moduledb 318 move_old_moduledb
260 319
261 if [[ -n $(grep ${CATEGORY}/${PN}-${PVR} ${MODULEDB_DIR}/moduledb) ]]; then 320 if grep -qs ${CATEGORY}/${PN}-${PVR} "${MODULEDB_DIR}"/moduledb ; then
262 einfo "Removing ${CATEGORY}/${PN}-${PVR} from moduledb." 321 einfo "Removing ${CATEGORY}/${PN}-${PVR} from moduledb."
263 sed -ie "/.*${CATEGORY}\/${PN}-${PVR}.*/d" ${MODULEDB_DIR}/moduledb 322 sed -i -e "/.*${CATEGORY}\/${PN}-${PVR}.*/d" "${MODULEDB_DIR}"/moduledb
264 fi 323 fi
265} 324}
266 325
326# @FUNCTION: set_kvobj
327# @DESCRIPTION:
328# It sets the KV_OBJ variable.
267set_kvobj() { 329set_kvobj() {
330 debug-print-function ${FUNCNAME} $*
331
268 if kernel_is 2 6 332 if kernel_is ge 2 6
269 then 333 then
270 KV_OBJ="ko" 334 KV_OBJ="ko"
271 else 335 else
272 KV_OBJ="o" 336 KV_OBJ="o"
273 fi 337 fi
274 # Do we really need to know this? 338 # Do we really need to know this?
275 # Lets silence it. 339 # Lets silence it.
276 # einfo "Using KV_OBJ=${KV_OBJ}" 340 # einfo "Using KV_OBJ=${KV_OBJ}"
277} 341}
278 342
343get-KERNEL_CC() {
344 debug-print-function ${FUNCNAME} $*
345
346 if [[ -n ${KERNEL_CC} ]] ; then
347 echo "${KERNEL_CC}"
348 return
349 fi
350
351 local kernel_cc
352 if [ -n "${KERNEL_ABI}" ]; then
353 # In future, an arch might want to define CC_$ABI
354 #kernel_cc="$(get_abi_CC)"
355 #[ -z "${kernel_cc}" ] &&
356 kernel_cc="$(tc-getCC $(ABI=${KERNEL_ABI} get_abi_CHOST))"
357 else
358 kernel_cc=$(tc-getCC)
359 fi
360 echo "${kernel_cc}"
361}
362
363# internal function
364#
365# FUNCTION:
366# USAGE: /path/to/the/modulename_without_extension
367# RETURN: A file in /etc/modules.d/ (kernel < 2.6) or /etc/modprobe.d/ (kernel >= 2.6)
368# DESCRIPTION:
369# This function will generate and install the neccessary modprobe.d/modules.d file from the
370# information contained in the modules exported parms.
371# (see the variables MODULESD_<modulename>_ENABLED, MODULESD_<modulename>_EXAMPLES,
372# MODULESD_<modulename>_ALIASES, MODULESD_<modulename>_ADDITION and MODULESD_<modulename>_DOCS).
373#
374# At the end the documentation specified with MODULESD_<modulename>_DOCS is installed.
279generate_modulesd() { 375generate_modulesd() {
280 # This function will generate the neccessary modules.d file from the 376 debug-print-function ${FUNCNAME} $*
281 # information contained in the modules exported parms
282 377
283 local currm_path currm currm_t t myIFS myVAR 378 local currm_path currm currm_t t myIFS myVAR
284 local module_docs module_enabled module_aliases \ 379 local module_docs module_enabled module_aliases \
285 module_additions module_examples module_modinfo module_opts 380 module_additions module_examples module_modinfo module_opts
286 381
320 module_modinfo="$(modinfo -p ${currm_path}.${KV_OBJ})" 415 module_modinfo="$(modinfo -p ${currm_path}.${KV_OBJ})"
321 module_config="${T}/modulesd-${currm}" 416 module_config="${T}/modulesd-${currm}"
322 417
323 ebegin "Preparing file for modules.d" 418 ebegin "Preparing file for modules.d"
324 #----------------------------------------------------------------------- 419 #-----------------------------------------------------------------------
325 echo "# modules.d configuration file for ${currm}" >> ${module_config} 420 echo "# modules.d configuration file for ${currm}" >> "${module_config}"
326 #----------------------------------------------------------------------- 421 #-----------------------------------------------------------------------
327 [[ -n ${module_docs} ]] && \ 422 [[ -n ${module_docs} ]] && \
328 echo "# For more information please read:" >> ${module_config} 423 echo "# For more information please read:" >> "${module_config}"
329 for t in ${module_docs} 424 for t in ${module_docs}
330 do 425 do
331 echo "# ${t//*\/}" >> ${module_config} 426 echo "# ${t//*\/}" >> "${module_config}"
332 done 427 done
333 echo >> ${module_config} 428 echo >> "${module_config}"
334 429
335 #----------------------------------------------------------------------- 430 #-----------------------------------------------------------------------
336 if [[ ${module_aliases} -gt 0 ]] 431 if [[ ${module_aliases} -gt 0 ]]
337 then 432 then
338 echo "# Internal Aliases - Do not edit" >> ${module_config} 433 echo "# Internal Aliases - Do not edit" >> "${module_config}"
339 echo "# ------------------------------" >> ${module_config} 434 echo "# ------------------------------" >> "${module_config}"
340 435
341 for((t=0; t<${module_aliases}; t++)) 436 for((t=0; t<${module_aliases}; t++))
342 do 437 do
343 echo "alias $(eval echo \${MODULESD_${currm}_ALIASES[$t]})" \ 438 echo "alias $(eval echo \${MODULESD_${currm}_ALIASES[$t]})" \
344 >> ${module_config} 439 >> "${module_config}"
345 done 440 done
346 echo '' >> ${module_config} 441 echo '' >> "${module_config}"
347 fi 442 fi
348 443
349 #----------------------------------------------------------------------- 444 #-----------------------------------------------------------------------
350 if [[ -n ${module_modinfo} ]] 445 if [[ -n ${module_modinfo} ]]
351 then 446 then
352 echo >> ${module_config} 447 echo >> "${module_config}"
353 echo "# Configurable module parameters" >> ${module_config} 448 echo "# Configurable module parameters" >> "${module_config}"
354 echo "# ------------------------------" >> ${module_config} 449 echo "# ------------------------------" >> "${module_config}"
355 myIFS="${IFS}" 450 myIFS="${IFS}"
356 IFS="$(echo -en "\n\b")" 451 IFS="$(echo -en "\n\b")"
357 452
358 for t in ${module_modinfo} 453 for t in ${module_modinfo}
359 do 454 do
360 myVAR="$(echo ${t#*:} | grep -e " [0-9][ =]" | sed "s:.*\([01][= ]\).*:\1:")" 455 myVAR="$(echo ${t#*:} | grep -e " [0-9][ =]" | sed "s:.*\([01][= ]\).*:\1:")"
361 if [[ -n ${myVAR} ]] 456 if [[ -n ${myVAR} ]]
362 then 457 then
363 module_opts="${module_opts} ${t%%:*}:${myVAR}" 458 module_opts="${module_opts} ${t%%:*}:${myVAR}"
364 fi 459 fi
365 echo -e "# ${t%%:*}:\t${t#*:}" >> ${module_config} 460 echo -e "# ${t%%:*}:\t${t#*:}" >> "${module_config}"
366 done 461 done
367 IFS="${myIFS}" 462 IFS="${myIFS}"
368 echo '' >> ${module_config} 463 echo '' >> "${module_config}"
369 fi 464 fi
370 465
371 #----------------------------------------------------------------------- 466 #-----------------------------------------------------------------------
372 if [[ $(eval echo \${MODULESD_${currm}_ALIASES[0]}) == guess ]] 467 if [[ $(eval echo \${MODULESD_${currm}_ALIASES[0]}) == guess ]]
373 then 468 then
374 # So lets do some guesswork eh? 469 # So lets do some guesswork eh?
375 if [[ -n ${module_opts} ]] 470 if [[ -n ${module_opts} ]]
376 then 471 then
377 echo "# For Example..." >> ${module_config} 472 echo "# For Example..." >> "${module_config}"
378 echo "# --------------" >> ${module_config} 473 echo "# --------------" >> "${module_config}"
379 for t in ${module_opts} 474 for t in ${module_opts}
380 do 475 do
381 echo "# options ${currm} ${t//:*}=${t//*:}" >> ${module_config} 476 echo "# options ${currm} ${t//:*}=${t//*:}" >> "${module_config}"
382 done 477 done
383 echo '' >> ${module_config} 478 echo '' >> "${module_config}"
384 fi 479 fi
385 elif [[ ${module_examples} -gt 0 ]] 480 elif [[ ${module_examples} -gt 0 ]]
386 then 481 then
387 echo "# For Example..." >> ${module_config} 482 echo "# For Example..." >> "${module_config}"
388 echo "# --------------" >> ${module_config} 483 echo "# --------------" >> "${module_config}"
389 for((t=0; t<${module_examples}; t++)) 484 for((t=0; t<${module_examples}; t++))
390 do 485 do
391 echo "options $(eval echo \${MODULESD_${currm}_EXAMPLES[$t]})" \ 486 echo "options $(eval echo \${MODULESD_${currm}_EXAMPLES[$t]})" \
392 >> ${module_config} 487 >> "${module_config}"
393 done 488 done
394 echo '' >> ${module_config} 489 echo '' >> "${module_config}"
395 fi 490 fi
396 491
397 #----------------------------------------------------------------------- 492 #-----------------------------------------------------------------------
398 if [[ ${module_additions} -gt 0 ]] 493 if [[ ${module_additions} -gt 0 ]]
399 then 494 then
400 for((t=0; t<${module_additions}; t++)) 495 for((t=0; t<${module_additions}; t++))
401 do 496 do
402 echo "$(eval echo \${MODULESD_${currm}_ADDITIONS[$t]})" \ 497 echo "$(eval echo \${MODULESD_${currm}_ADDITIONS[$t]})" \
403 >> ${module_config} 498 >> "${module_config}"
404 done 499 done
405 echo '' >> ${module_config} 500 echo '' >> "${module_config}"
406 fi 501 fi
407 502
408 #----------------------------------------------------------------------- 503 #-----------------------------------------------------------------------
409 504
410 # then we install it 505 # then we install it
506 if kernel_is ge 2 6; then
507 insinto /etc/modprobe.d
508 else
411 insinto /etc/modules.d 509 insinto /etc/modules.d
510 fi
412 newins ${module_config} ${currm_path//*\/} 511 newins "${module_config}" "${currm_path//*\/}.conf"
413 512
414 # and install any documentation we might have. 513 # and install any documentation we might have.
415 [[ -n ${module_docs} ]] && dodoc ${module_docs} 514 [[ -n ${module_docs} ]] && dodoc ${module_docs}
416 done 515 done
417 eend 0 516 eend 0
418 return 0 517 return 0
419} 518}
420 519
520# internal function
521#
522# FUNCTION: find_module_params
523# USAGE: A string "NAME(LIBDIR:SRCDIR:OBJDIR)"
524# RETURN: The string "modulename:NAME libdir:LIBDIR srcdir:SRCDIR objdir:OBJDIR"
525# DESCRIPTION:
526# Analyze the specification NAME(LIBDIR:SRCDIR:OBJDIR) of one module as described in MODULE_NAMES.
421find_module_params() { 527find_module_params() {
528 debug-print-function ${FUNCNAME} $*
529
422 local matched_offset=0 matched_opts=0 test="${@}" temp_var result 530 local matched_offset=0 matched_opts=0 test="${@}" temp_var result
423 local i=0 y=0 z=0 531 local i=0 y=0 z=0
424 532
425 for((i=0; i<=${#test}; i++)) 533 for((i=0; i<=${#test}; i++))
426 do 534 do
459} 567}
460 568
461# default ebuild functions 569# default ebuild functions
462# -------------------------------- 570# --------------------------------
463 571
572# @FUNCTION: linux-mod_pkg_setup
573# @DESCRIPTION:
574# It checks the CONFIG_CHECK options (see linux-info.eclass(5)), verifies that the kernel is
575# configured, verifies that the sources are prepared, verifies that the modules support is builtin
576# in the kernel and sets the object extension KV_OBJ.
464linux-mod_pkg_setup() { 577linux-mod_pkg_setup() {
578 debug-print-function ${FUNCNAME} $*
579
580 local is_bin="${MERGE_TYPE}"
581
582 # If we are installing a binpkg, take a different path.
583 # use MERGE_TYPE if available (eapi>=4); else use non-PMS EMERGE_FROM (eapi<4)
584 if has ${EAPI} 0 1 2 3; then
585 is_bin=${EMERGE_FROM}
586 fi
587
588 if [[ ${is_bin} == binary ]]; then
589 linux-mod_pkg_setup_binary
590 return
591 fi
592
465 linux-info_pkg_setup; 593 linux-info_pkg_setup;
594 require_configured_kernel
466 check_kernel_built; 595 check_kernel_built;
467 strip_modulenames; 596 strip_modulenames;
468 [[ -n ${MODULE_NAMES} ]] && check_modules_supported 597 [[ -n ${MODULE_NAMES} ]] && check_modules_supported
469 set_kvobj; 598 set_kvobj;
470 # Commented out with permission from johnm until a fixed version for arches 599 # Commented out with permission from johnm until a fixed version for arches
471 # who intentionally use different kernel and userland compilers can be 600 # who intentionally use different kernel and userland compilers can be
472 # introduced - Jason Wever <weeve@gentoo.org>, 23 Oct 2005 601 # introduced - Jason Wever <weeve@gentoo.org>, 23 Oct 2005
473 #check_vermagic; 602 #check_vermagic;
474} 603}
475 604
605# @FUNCTION: linux-mod_pkg_setup_binary
606# @DESCRIPTION:
607# Perform all kernel option checks non-fatally, as the .config and
608# /proc/config.gz might not be present. Do not do anything that requires kernel
609# sources.
610linux-mod_pkg_setup_binary() {
611 debug-print-function ${FUNCNAME} $*
612 local new_CONFIG_CHECK
613 # ~ needs always to be quoted, else bash expands it.
614 for config in $CONFIG_CHECK ; do
615 optional='~'
616 [[ ${config:0:1} == "~" ]] && optional=''
617 new_CONFIG_CHECK="${new_CONFIG_CHECK} ${optional}${config}"
618 done
619 export CONFIG_CHECK="${new_CONFIG_CHECK}"
620 linux-info_pkg_setup;
621}
622
476strip_modulenames() { 623strip_modulenames() {
624 debug-print-function ${FUNCNAME} $*
625
477 local i 626 local i
478 for i in ${MODULE_IGNORE}; do 627 for i in ${MODULE_IGNORE}; do
479 MODULE_NAMES=${MODULE_NAMES//${i}(*} 628 MODULE_NAMES=${MODULE_NAMES//${i}(*}
480 done 629 done
481} 630}
482 631
632# @FUNCTION: linux-mod_src_compile
633# @DESCRIPTION:
634# It compiles all the modules specified in MODULE_NAMES. For each module the econf command is
635# executed only if ECONF_PARAMS is defined, the name of the target is specified by BUILD_TARGETS
636# while the options are in BUILD_PARAMS (all the modules share these variables). The compilation
637# happens inside ${srcdir}.
638#
639# Look at the description of these variables for more details.
483linux-mod_src_compile() { 640linux-mod_src_compile() {
641 debug-print-function ${FUNCNAME} $*
642
484 local modulename libdir srcdir objdir i n myARCH="${ARCH}" myABI="${ABI}" 643 local modulename libdir srcdir objdir i n myABI="${ABI}"
485 ARCH="$(tc-arch-kernel)" 644 set_arch_to_kernel
486 ABI="${KERNEL_ABI}" 645 ABI="${KERNEL_ABI}"
487 CC_HOSTCC=$(tc-getBUILD_CC)
488 CC_CC=$(tc-getCC)
489 646
490 BUILD_TARGETS=${BUILD_TARGETS:-clean module} 647 BUILD_TARGETS=${BUILD_TARGETS:-clean module}
648 strip_modulenames;
649 cd "${S}"
650 touch Module.symvers
651 for i in ${MODULE_NAMES}
652 do
653 unset libdir srcdir objdir
654 for n in $(find_module_params ${i})
655 do
656 eval ${n/:*}=${n/*:/}
657 done
658 libdir=${libdir:-misc}
659 srcdir=${srcdir:-${S}}
660 objdir=${objdir:-${srcdir}}
661
662 if [ ! -f "${srcdir}/.built" ];
663 then
664 cd "${srcdir}"
665 ln -s "${S}"/Module.symvers Module.symvers
666 einfo "Preparing ${modulename} module"
667 if [[ -n ${ECONF_PARAMS} ]]
668 then
669 econf ${ECONF_PARAMS} || \
670 die "Unable to run econf ${ECONF_PARAMS}"
671 fi
672
673 # This looks messy, but it is needed to handle multiple variables
674 # being passed in the BUILD_* stuff where the variables also have
675 # spaces that must be preserved. If don't do this, then the stuff
676 # inside the variables gets used as targets for Make, which then
677 # fails.
678 eval "emake HOSTCC=\"$(tc-getBUILD_CC)\" \
679 CROSS_COMPILE=${CHOST}- \
680 LDFLAGS=\"$(get_abi_LDFLAGS)\" \
681 ${BUILD_FIXES} \
682 ${BUILD_PARAMS} \
683 ${BUILD_TARGETS} " \
684 || die "Unable to emake HOSTCC="$(tc-getBUILD_CC)" CROSS_COMPILE=${CHOST}- LDFLAGS="$(get_abi_LDFLAGS)" ${BUILD_FIXES} ${BUILD_PARAMS} ${BUILD_TARGETS}"
685 cd "${OLDPWD}"
686 touch "${srcdir}"/.built
687 fi
688 done
689
690 set_arch_to_portage
691 ABI="${myABI}"
692}
693
694# @FUNCTION: linux-mod_src_install
695# @DESCRIPTION:
696# It install the modules specified in MODULES_NAME. The modules should be inside the ${objdir}
697# directory and they are installed inside /lib/modules/${KV_FULL}/${libdir}.
698#
699# The modprobe.d/modules.d configuration file is automatically generated if the
700# MODULESD_<modulename>_* variables are defined. The only way to stop this process is by
701# setting MODULESD_<modulename>_ENABLED=no. At the end the documentation specified via
702# MODULESD_<modulename>_DOCS is also installed.
703#
704# Look at the description of these variables for more details.
705linux-mod_src_install() {
706 debug-print-function ${FUNCNAME} $*
707
708 local modulename libdir srcdir objdir i n
709
491 strip_modulenames; 710 strip_modulenames;
492 for i in ${MODULE_NAMES} 711 for i in ${MODULE_NAMES}
493 do 712 do
494 unset libdir srcdir objdir 713 unset libdir srcdir objdir
495 for n in $(find_module_params ${i}) 714 for n in $(find_module_params ${i})
498 done 717 done
499 libdir=${libdir:-misc} 718 libdir=${libdir:-misc}
500 srcdir=${srcdir:-${S}} 719 srcdir=${srcdir:-${S}}
501 objdir=${objdir:-${srcdir}} 720 objdir=${objdir:-${srcdir}}
502 721
503 if [ ! -f "${srcdir}/.built" ];
504 then
505 cd ${srcdir}
506 einfo "Preparing ${modulename} module"
507 if [[ -n ${ECONF_PARAMS} ]]
508 then
509 econf ${ECONF_PARAMS} || \
510 die "Unable to run econf ${ECONF_PARAMS}"
511 fi
512
513 emake HOSTCC=${CC_HOSTCC} CC=${CC_CC}\
514 ${BUILD_FIXES} ${BUILD_PARAMS} ${BUILD_TARGETS} \
515 || die "Unable to make \
516 ${BUILD_FIXES} ${BUILD_PARAMS} ${BUILD_TARGETS}."
517 touch ${srcdir}/.built
518 cd ${OLDPWD}
519 fi
520 done
521
522 ARCH="${myARCH}"
523 ABI="${myABI}"
524}
525
526linux-mod_src_install() {
527 local modulename libdir srcdir objdir i n
528
529 strip_modulenames;
530 for i in ${MODULE_NAMES}
531 do
532 unset libdir srcdir objdir
533 for n in $(find_module_params ${i})
534 do
535 eval ${n/:*}=${n/*:/}
536 done
537 libdir=${libdir:-misc}
538 srcdir=${srcdir:-${S}}
539 objdir=${objdir:-${srcdir}}
540
541 einfo "Installing ${modulename} module" 722 einfo "Installing ${modulename} module"
542 cd ${objdir} || die "${objdir} does not exist" 723 cd "${objdir}" || die "${objdir} does not exist"
543 insinto /lib/modules/${KV_FULL}/${libdir} 724 insinto /lib/modules/${KV_FULL}/${libdir}
544 doins ${modulename}.${KV_OBJ} || die "doins ${modulename}.${KV_OBJ} failed" 725 doins ${modulename}.${KV_OBJ} || die "doins ${modulename}.${KV_OBJ} failed"
545 cd ${OLDPWD} 726 cd "${OLDPWD}"
546 727
547 generate_modulesd ${objdir}/${modulename} 728 generate_modulesd "${objdir}/${modulename}"
548 done 729 done
549} 730}
550 731
732# @FUNCTION: linux-mod_pkg_preinst
733# @DESCRIPTION:
734# It checks what to do after having merged the package.
735linux-mod_pkg_preinst() {
736 debug-print-function ${FUNCNAME} $*
737
738 [ -d "${D}lib/modules" ] && UPDATE_DEPMOD=true || UPDATE_DEPMOD=false
739 [ -d "${D}etc/modules.d" ] && UPDATE_MODULES=true || UPDATE_MODULES=false
740 [ -d "${D}lib/modules" ] && UPDATE_MODULEDB=true || UPDATE_MODULEDB=false
741}
742
743# @FUNCTION: linux-mod_pkg_postinst
744# @DESCRIPTION:
745# It executes /sbin/depmod and adds the package to the /var/lib/module-rebuild/moduledb
746# database (if ${D}/lib/modules is created) and it runs /sbin/update-modules
747# (if ${D}/etc/modules.d is created).
551linux-mod_pkg_postinst() { 748linux-mod_pkg_postinst() {
552 update_depmod; 749 debug-print-function ${FUNCNAME} $*
553 update_modules;
554 update_moduledb;
555}
556 750
751 ${UPDATE_DEPMOD} && update_depmod;
752 ${UPDATE_MODULES} && update_modules;
753 ${UPDATE_MODULEDB} && update_moduledb;
754}
755
756# @FUNCTION: linux-mod_pkg_postrm
757# @DESCRIPTION:
758# It removes the package from the /var/lib/module-rebuild/moduledb database but it doens't
759# call /sbin/depmod and /sbin/update-modules because the modules are still installed.
557linux-mod_pkg_postrm() { 760linux-mod_pkg_postrm() {
761 debug-print-function ${FUNCNAME} $*
558 remove_moduledb; 762 remove_moduledb;
559} 763}

Legend:
Removed from v.1.64  
changed lines
  Added in v.1.102

  ViewVC Help
Powered by ViewVC 1.1.20